#pragma once
#include "simsbasic.h"
#include <QHash>


/// <summary>
/// ڴʵʵ
/// </summary>
class SIMSBASIC_EXPORT RtWsEntity : public WsEntity, public ComponentSet, public std::enable_shared_from_this<RtWsEntity> {
private:
	uint64_t _entity_id = 0;
	QString _templet_name, _runtime_name;
	QHash<QString, std::shared_ptr<WsComponent>> _comps_list;

public:
	explicit RtWsEntity();
	virtual ~RtWsEntity() = default;

	/// <summary>
	/// ñʵģ
	/// </summary>
	/// <param name="name">ģ</param>
	virtual void resetTemplet(const QString& name);
	/// <summary>
	/// ȡʵģ
	/// </summary>
	/// <returns>ģ</returns>
	virtual QString templetName() const;

	/// <summary>
	/// ñʵID
	/// </summary>
	/// <param name="id"></param>
	virtual void resetID(uint64_t id);
	/// <summary>
	/// ȡʵID
	/// </summary>
	/// <returns></returns>
	virtual uint64_t entityID() const;
	/// <summary>
	/// ñʵ
	/// </summary>
	/// <param name="name"></param>
	virtual void resetName(const QString& name);
	/// <summary>
	/// ȡʵ
	/// </summary>
	/// <returns></returns>
	virtual QString name() const;

	/// <summary>
	/// Ϊʵָ͵Ĳ
	/// </summary>
	/// <param name="ins"></param>
	virtual void append(std::shared_ptr<WsComponent> ins) override;
	/// <summary>
	/// Ƴָ͵Ĳʵ
	/// </summary>
	/// <param name="component_type"></param>
	virtual void remove(const QString& component_type) override;
	/// <summary>
	/// ȡʵڰвʵ
	/// </summary>
	/// <returns></returns>
	virtual QList<std::shared_ptr<WsComponent>> components() const override;

	/// <summary>
	/// ȿ¡ʵһ
	/// </summary>
	/// <returns></returns>
	virtual std::shared_ptr<Serializable> newDefault() const override;

	/// <summary>
	/// Ϣ
	/// </summary>
	/// <returns>Ϣͼ</returns>
	virtual QList<QString> inputTypes() const;
	/// <summary>
	/// ָͨǩȡ
	/// </summary>
	/// <param name="t">ǩ</param>
	/// <returns>ӿ</returns>
	virtual QList<WsRespondEntry> getRespondWithSignature(const WsRespondSignatureType& t) const;
	/// <summary>
	/// ͨϢͻȡ
	/// </summary>
	/// <param name="msg_type">Ϣ</param>
	/// <returns>ӿб</returns>
	virtual QList<WsRespondEntry> getRespondWithInType(const QString& msg_type) const override;
	
	// ͨ Serializable ̳
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// ʱʵ
/// </summary>
class SIMSBASIC_EXPORT RtEntityManager : public WsEntity, public ComponentSet,
	public std::enable_shared_from_this<RtEntityManager>
{
public:
	static const uint64_t const_id = 0x01ff;
	QHash<QString, std::shared_ptr<WsComponent>> _comps_list;

	QString templetName() const override;
	uint64_t entityID() const override;
	QString name() const override;
	void append(std::shared_ptr<WsComponent> ins) override;
	void remove(const QString& component_type) override;
	QList<std::shared_ptr<WsComponent>> components() const override;

	std::shared_ptr<Serializable> newDefault() const override;
	QList<WsRespondEntry> getRespondWithSignature(const WsRespondSignatureType& t) const override;
	QList<WsRespondEntry> getRespondWithInType(const QString& msg_type) const override;

	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

class SIMSBASIC_EXPORT RtResourceManager : public WsEntity, public ComponentSet,
	public std::enable_shared_from_this<RtResourceManager>
{
public:
	static const uint64_t const_id = 0x01f0;
	QHash<QString, std::shared_ptr<WsComponent>> _comps_list;

	QString templetName() const override;
	uint64_t entityID() const override;
	QString name() const override;

	std::shared_ptr<Serializable> newDefault() const override;
	QList<WsRespondEntry> getRespondWithSignature(const WsRespondSignatureType& t) const override;
	QList<WsRespondEntry> getRespondWithInType(const QString& msg_type) const override;

	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;

	void append(std::shared_ptr<WsComponent> ins) override;
	void remove(const QString& component_type) override;
	QList<std::shared_ptr<WsComponent>> components() const override;

};
